/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */



/**
 * \file base/Prototype.h
 *
 *  Created on: 20 déc. 2010
 *      Author: Alexandre Tuleu
 */

#ifndef BIOROB_CPP_BASE_PROTOTYPE_H_
#define BIOROB_CPP_BASE_PROTOTYPE_H_

#include <tr1/memory>


#define IS_PROTO_IMPLEMENTATION(ClassName,BaseClassName) public :\
	virtual std::tr1::shared_ptr<BaseClassName> Clone() const { \
		return std::tr1::shared_ptr<BaseClassName>(new ClassName(*this)); \
}\
private :


template <typename T>
class Prototype{
public :
	Prototype(){}
	virtual ~Prototype(){}
	virtual std::tr1::shared_ptr<T> Clone() const = 0;
};



#endif /* BIOROB_CPP_BASE_PROTOTYPE_H_ */
